/*********************************************************/
/** CIRCLE - The adaptation of the Ketchapp's game		**/
/**														**/
/** @author		TheProg for planete-casio				**/
/** @contact	the.prog@laposte.net					**/
/** 													**/
/** @date 01-01-2015									**/
/*********************************************************/

#include "fxlib.h"
#include "CIRCLE.h"
#include "engine.h"
#include "MonochromeLib.h"

#include <stdlib.h>
#include <stdio.h>

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	char buf[20];

	int lenght;
	int play = 1;
	int status = 0;
	int score = 0;
	int pressed = 0;
	unsigned int bind = KEY_CTRL_EXE;
	float yCircle = -100.;
	float vCircle = 0.;
	
	Start();
	Line_init();
	
	while(play)
	{
		ML_clear_vram();
		
		Line_generate();
		Line_move();
		Line_draw();
		
		// if 'status == 0' menu -- ok
		if(status == 0)
		{
			Menu(&play, &status, bind);
		}
		
		// if 'status == 1' play -- ok
		else if(status == 1)
		{
			// Init
			if(yCircle == -100.)
			{
				yCircle = Line_pos();
				score = 0;
				vCircle = 0.;
			}
			
			// Draw
			lenght = sprintf(buf, "SCORE:%d", score);
			PrintCenter(0, buf, lenght, 0);
			ML_ellipse(POS_CIRCLE, (int)yCircle, CIRCLE_WEIGHT, CIRCLE_WEIGHT*2, ML_BLACK);
			ML_ellipse(POS_CIRCLE, (int)yCircle, CIRCLE_WEIGHT+1, CIRCLE_WEIGHT*2, ML_BLACK);
			ML_ellipse(POS_CIRCLE, (int)yCircle, CIRCLE_WEIGHT+2, CIRCLE_WEIGHT*2+1, ML_BLACK);
			ML_display_vram();
			
			// Crash
			if(Line_colision(yCircle))
				status = -1;
			
			// jump
			if(pressed && IsKeyUp(bind))
				pressed = 0;
			if(IsKeyDown(bind) && !pressed)
			{
				pressed = 1;
				vCircle = -.9;
				score ++;
			}
			if(vCircle < 3.)
				vCircle += .04;
			yCircle += vCircle;
			
			// Quit
			if(IsKeyDown(KEY_CTRL_EXIT))
			{
				while(IsKeyDown(KEY_CTRL_EXIT));
				status = 0;
			}
			
			Sleep(SPEED);
		}
		
		// if 'status == 2' options -- ok
		else if(status == 2)
		{
			Options(&status, &bind);
		}
		
		// if 'status == -1' crash -- ok
		else if(status == -1)
		{
			ML_rectangle(22, 22, 106, 46, 1, ML_BLACK, ML_WHITE);
			PrintCenter(24, "CRASH!", 6, 1);
			
			lenght = sprintf(buf, "SCORE: %d", score);
			PrintCenter(32, buf, lenght, 0);
			lenght = sprintf(buf, "PRESS %s", KeyName(bind));
			PrintCenter(39, buf, lenght, 0);
			ML_display_vram();
			
			if(IsKeyDown(bind) || IsKeyDown(KEY_CTRL_EXIT))
			{
				while(IsKeyDown(bind) || IsKeyDown(KEY_CTRL_EXIT));
				status = 0;
				yCircle = -100.;
			}
			
			Sleep(SPEED);
		}
	}
	
	Line_quit();
	
	return 1;
}

// Draw the starting screen -- ok
void Start()
{
	int i;
	
	PrintCenter(29, "CIRCLE", 6, 1);
	PrintCenter(59, "BY T.PROG", 9, 0);
	
	for(i = 0; i<39; i++)
	{
		ML_line(45, 37, 46+i, 37, ML_BLACK);
		ML_display_vram();
		Sleep(25);
		if(IsKeyDown(KEY_CTRL_EXE))
			break;
	}
	
	ML_clear_vram();
}

// Draw the menu -- ok
void Menu(int* play, int* status, unsigned int bind)
{
	static int choix = 0;
	unsigned int key;
	
	ML_rectangle(18, 17, 110, 51, 1, ML_BLACK, ML_WHITE);
	PrintCenter(20, "MENU", 4, 1);
	PrintCenter(30+7*choix, ">          <", 12, 0);
	PrintCenter(30, "PLAY", 4, 0);
	PrintCenter(37, "OPTIONS", 7, 0);
	PrintCenter(44, "EXIT", 4, 0);
	
#ifdef ECO_ENERGY
	GetKey(&key);
	
	switch(key)
	{
		case KEY_CTRL_EXE:
		case bind:
			if(choix == 0)
			{
				*status = 1;
			}
			else if(choix == 1)
			{
				choix = 0;
				*status = 2;
			}
			else if(choix == 2)
			{
				*play = 0;
			}
			break;
		case KEY_CTRL_EXIT:
			*play = 0;
			break;
		case KEY_CTRL_DOWN:
			choix = (choix+1)%3;
			break;
		case KEY_CTRL_UP:
			choix = (choix+2)%3;
			break;
	}
#else
	ML_display_vram();
	if(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(bind))
	{
		while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(bind));
		if(choix == 0)
		{
			*status = 1;
		}
		else if(choix == 1)
		{
			choix = 0;
			*status = 2;
		}
		else if(choix == 2)
		{
			*play = 0;
		}
	}
	else if(IsKeyDown(KEY_CTRL_EXIT))
	{
		while(IsKeyDown(KEY_CTRL_EXIT));
		*play = 0;
	}
	else if(IsKeyDown(KEY_CTRL_DOWN))
	{
		while(IsKeyDown(KEY_CTRL_DOWN));
		choix = (choix+1)%3;
	}
	else if(IsKeyDown(KEY_CTRL_UP))
	{
		while(IsKeyDown(KEY_CTRL_UP));
		choix = (choix+2)%3;
	}
	Sleep(SPEED);
#endif

}

// Draw the option -- ok
void Options(int* status, int* bind)
{
	static int choix = 0;
	unsigned int key;
	
	ML_rectangle(18, 17, 110, 51, 1, ML_BLACK, ML_WHITE);
	PrintCenter(20, "OPTIONS", 7, 1);
	PrintCenter(30+7*choix, ">            <", 14, 0);
	PrintCenter(30, "BIND JUMP", 9, 0);
	PrintCenter(37, "CONTRAST", 8, 0);
	PrintCenter(44, "BACK", 4, 0);
	SaveDisp(1);

#ifdef ECO_ENERGY
	GetKey(&key);
	
	switch(key)
	{
		case KEY_CTRL_EXE:
		case *bind:
			if(choix == 0)
				BindJump(bind);
			else if(choix == 1)
				SetContrast();
			else if(choix == 2)
				*status = 0;
			
			break;
		case KEY_CTRL_EXIT:
			*status = 0;
			break;
		case KEY_CTRL_DOWN:
			choix = (choix+1)%3;
			break;
		case KEY_CTRL_UP:
			choix = (choix+2)%3;
			break;
	}
#else
	ML_display_vram();
	
	if(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(*bind))
	{
		while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(*bind));
		if(choix == 0)
			BindJump(bind);
		else if(choix == 1)
			SetContrast();
		else if(choix == 2)
			*status = 0;
	}
	else if(IsKeyDown(KEY_CTRL_EXIT))
	{
		while(IsKeyDown(KEY_CTRL_EXIT));
		*status = 0;
	}
	else if(IsKeyDown(KEY_CTRL_DOWN))
	{
		while(IsKeyDown(KEY_CTRL_DOWN));
		choix = (choix+1)%3;
	}
	else if(IsKeyDown(KEY_CTRL_UP))
	{
		while(IsKeyDown(KEY_CTRL_UP));
		choix = (choix+2)%3;
	}
	Sleep(SPEED);
#endif
}

// Change key for jump -- ok
void BindJump(int* bind)
{
	char buf[20];
	unsigned int key;
	int choix = 0;
	int lenght;
	
	while(1)
	{
		RestoreDisp(1);
		ML_rectangle(22, 22, 106, 46, 1, ML_BLACK, ML_WHITE);
		PrintCenter(24, "BIND JUMP", 9, 1);
		
		lenght = sprintf(buf, "ACTUAL: %s", KeyName(*bind));
		PrintCenter(32, buf, lenght, 0);
		if(choix == 0)
			PrintCenter(39, ">CHANGE   BACK", 14, 0);
		else
			PrintCenter(39, " CHANGE  >BACK", 14, 0);
		
		GetKey(&key);
		
		switch(key)
		{
			case KEY_CTRL_EXE:
				while(IsKeyDown(KEY_CTRL_EXE));
				if(choix == 0)
				{
					ML_rectangle(10, 27, 118, 37, 1, ML_BLACK, ML_WHITE);
					PrintCenter(29, "PRESS ANY KEY", 13, 1);
					
					GetKey(bind);
					
					if(*bind == KEY_CTRL_EXIT)
						*bind = KEY_CTRL_EXE;
				}
				else
					return;
				break;
			case KEY_CTRL_EXIT:
				while(IsKeyDown(KEY_CTRL_EXIT));
				return;
			case KEY_CTRL_DOWN:
			case KEY_CTRL_UP:
			case KEY_CTRL_LEFT:
			case KEY_CTRL_RIGHT:
				choix = (choix+1)%2;
		}
	}
	
}

// Set the contrast -- ok
void SetContrast()
{
	unsigned char contrast = ML_CONTRAST_MIN+30;
	unsigned int key;
	
	while(1)
	{
		RestoreDisp(1);
		ML_rectangle(22, 22, 106, 46, 1, ML_BLACK, ML_WHITE);
		PrintCenter(24, "SET CONTRAST", 12, 1);
		ML_rectangle(34, 32, 94, 44, 1, ML_BLACK, ML_WHITE);
		ML_rectangle(34, 32, 34+contrast-ML_CONTRAST_MIN, 44, 1, ML_BLACK, ML_BLACK);
		
		ML_set_contrast(contrast);
		
		GetKey(&key);
		
		if(key == KEY_CTRL_LEFT && contrast > ML_CONTRAST_MIN)
			contrast--;
		if(key == KEY_CTRL_RIGHT && contrast < ML_CONTRAST_MAX)
			contrast++;
		if(key == KEY_CTRL_EXE || key == KEY_CTRL_EXIT)
			break;
	}
	while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(KEY_CTRL_EXIT));
}


// Get the key's name -- ok
char* KeyName(unsigned int key)
{
	switch(key)
	{
	// Numbers
		case KEY_CHAR_0:
			return "[0]";
		case KEY_CHAR_1:
			return "[1]";
		case KEY_CHAR_2:
			return "[2]";
		case KEY_CHAR_3:
			return "[3]";
		case KEY_CHAR_4:
			return "[4]";
		case KEY_CHAR_5:
			return "[5]";
		case KEY_CHAR_6:
			return "[6]";
		case KEY_CHAR_7:
			return "[7]";
		case KEY_CHAR_8:
			return "[8]";
		case KEY_CHAR_9:
			return "[9]";
			
	// Letters
		case KEY_CHAR_A:
			return "[A]";
		case KEY_CHAR_B:
			return "[B]";
		case KEY_CHAR_C:
			return "[C]";
		case KEY_CHAR_D:
			return "[D]";
		case KEY_CHAR_E:
			return "[E]";
		case KEY_CHAR_F:
			return "[F]";
		case KEY_CHAR_G:
			return "[G]";
		case KEY_CHAR_H:
			return "[H]";
		case KEY_CHAR_I:
			return "[I]";
		case KEY_CHAR_J:
			return "[J]";
		case KEY_CHAR_K:
			return "[K]";
		case KEY_CHAR_L:
			return "[L]";
		case KEY_CHAR_M:
			return "[M]";
		case KEY_CHAR_N:
			return "[N]";
		case KEY_CHAR_O:
			return "[O]";
		case KEY_CHAR_P:
			return "[P]";
		case KEY_CHAR_Q:
			return "[Q]";
		case KEY_CHAR_R:
			return "[R]";
		case KEY_CHAR_S:
			return "[S]";
		case KEY_CHAR_T:
			return "[T]";
		case KEY_CHAR_U:
			return "[U]";
		case KEY_CHAR_V:
			return "[V]";
		case KEY_CHAR_W:
			return "[W]";
		case KEY_CHAR_X:
			return "[X]";
		case KEY_CHAR_Y:
			return "[Y]";
		case KEY_CHAR_Z:
			return "[Z]";
	
	// Others
		case KEY_CHAR_DP:
			return "[.]\0";
		case KEY_CHAR_EXP:
			return "[E^]\0";
		case KEY_CHAR_PMINUS:
			return "[(-)]\0";
		case KEY_CHAR_PLUS:
			return "[+]\0";
		case KEY_CHAR_MINUS:
			return "[-]\0";
		case KEY_CHAR_MULT:
			return "[x]\0";
		case KEY_CHAR_DIV:
			return "[/]\0";
		case KEY_CHAR_FRAC:
			return "[FRAC]\0";
		case KEY_CHAR_LPAR:
			return "[(]\0";
		case KEY_CHAR_RPAR:
			return "[)]\0";
		case KEY_CHAR_COMMA:
			return "[,]\0";
		case KEY_CHAR_STORE:
			return "[->]\0";
		case KEY_CHAR_LOG:
			return "[log]\0";
		case KEY_CHAR_LN:
			return "[ln]\0";
		case KEY_CHAR_SIN:
			return "[sin]\0";
		case KEY_CHAR_COS:
			return "[cos]\0";
		case KEY_CHAR_TAN:
			return "[tan]\0";
		case KEY_CHAR_SQUARE:
			return "[x^2]\0";
		case KEY_CHAR_POW:
			return "[^]\0";
			
		case KEY_CHAR_IMGNRY:
			return "i";
		case KEY_CHAR_LIST:
			return "[List]";
		case KEY_CHAR_MAT:
			return "[Mat]";
		case KEY_CHAR_EQUAL:
			return "[=]";
		case KEY_CHAR_PI:
			return "[Pi]";
		case KEY_CHAR_ANS:
			return "[Ans]";
		case KEY_CHAR_LBRCKT:
			return "[[]";
		case KEY_CHAR_RBRCKT:
			return "[]]";
		case KEY_CHAR_LBRACE:
			return "[{]";
		case KEY_CHAR_RBRACE:
			return "[}]";
		case KEY_CHAR_CR:
			return "[CR]";
		case KEY_CHAR_CUBEROOT:
			return "[CBRT]";
		case KEY_CHAR_RECIP:
			return "[x^-1]";
		case KEY_CHAR_ANGLE:
			return "[Angle]";
		case KEY_CHAR_EXPN10:
			return "[10^x]";
		case KEY_CHAR_EXPN:
			return "[e^]";
		case KEY_CHAR_ASIN:
			return "[asin]";
		case KEY_CHAR_ACOS:
			return "[acos]";
		case KEY_CHAR_ATAN:
			return "[atan]";
		case KEY_CHAR_ROOT:
			return "[SQRT]";
		case KEY_CHAR_POWROOT:
			return "[Root^x]";
		case KEY_CHAR_SPACE:
			return "[SPACE]";
		case KEY_CHAR_DQUATE:
			return "[\"]";
		case KEY_CHAR_VALR:
			return "[r]";
		case KEY_CHAR_THETA:
			return "[theta]";

	// Control codes
		case KEY_CTRL_NOP:
			return "[NOP]";
		case KEY_CTRL_EXE:
			return "[EXE]";
		case KEY_CTRL_DEL:
			return "[Del]";
		case KEY_CTRL_AC:
			return "[Ac/On]";
		case KEY_CTRL_FD:
			return "[F-D]";
		case KEY_CTRL_XTT:
			return "[X,O,T]";
		case KEY_CTRL_EXIT:
			return "[EXIT]";
		case KEY_CTRL_SHIFT:
			return "[SHIFT]";
		case KEY_CTRL_ALPHA:
			return "[ALPHA]";
		case KEY_CTRL_OPTN:
			return "[OPTN]";
		case KEY_CTRL_VARS:
			return "[VARS]";
		case KEY_CTRL_UP:
			return "[UP]";
		case KEY_CTRL_DOWN:
			return "[DOWN]";
		case KEY_CTRL_LEFT:
			return "[LEFT]";
		case KEY_CTRL_RIGHT:
			return "[RIGHT]";
		case KEY_CTRL_F1:
			return "[F1]";
		case KEY_CTRL_F2:
			return "[F2]";
		case KEY_CTRL_F3:
			return "[F3]";
		case KEY_CTRL_F4:
			return "[F4]";
		case KEY_CTRL_F5:
			return "[F5]";
		case KEY_CTRL_F6:
			return "[F6]";
		case KEY_CTRL_CATALOG:
			return "[CATALOG]";
		case KEY_CTRL_CAPTURE:
			return "[CAPTURE]";
		case KEY_CTRL_CLIP:
			return "[CLIP]";
		case KEY_CTRL_PASTE:
			return "[PASTE]";
		case KEY_CTRL_INS:
			return "[INS]";
		case KEY_CTRL_MIXEDFRAC:
			return "[MixedFrac]";
		case KEY_CTRL_FRACCNVRT:
			return "[FracConvert]";
		case KEY_CTRL_QUIT:
			return "[QUIT]";
		case KEY_CTRL_PRGM:
			return "[PRGM]";
		case KEY_CTRL_SETUP:
			return "[SETUP]";
		case KEY_CTRL_PAGEUP:
			return "[PAGEUP]";
		case KEY_CTRL_PAGEDOWN:
			return "[PAGEDOWN]";
		case KEY_CTRL_MENU:
			return "[MENU]";
		case KEY_CTRL_RESERVE1:
			return "[RESERVE1]";
		case KEY_CTRL_RESERVE2:
			return "[RESERVE2]";
		case KEY_CTRL_RESERVE3:
			return "[RESERVE3]";
			
	}
	
	return "?";
}

// Print at the center -- ok
void PrintCenter(int y, char* string, int lenght, int caps)
{
	if(caps)
		PrintXY(64-lenght*3, y, (unsigned char*)string, 0);
	else
		PrintMini(64-lenght*2, y, (unsigned char*)string, 0);
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum){return INIT_ADDIN_APPLICATION(isAppli, OptionNum);}
#pragma section

