#include "engine.h"
#include "MonochromeLib.h"
#include <stdlib.h>

Line* lines = NULL;

// Initialize Lines -- ok
void Line_init()
{
	srand(RTC_getTicks());
	
	lines = calloc(2, sizeof(Line));
	lines[0].x[0] = 0;
	lines[0].x[1] = 128;
	lines[0].y[0] = 32;
	lines[0].y[1] = 32;
	lines[0].exist = 1;
	
	lines[1].exist = 0;
}

// Control lines -- ~ok
int Line_generate()
{
	int i;
	int lastLine = 0;
	
	lastLine = Line_cout()-1;
	// add a line
	if(lines[lastLine].x[1] <= 128)
	{
		lines = realloc(lines, (lastLine+2)*sizeof(Line));
		if(lines == NULL)
			return -1;
		
		lines[lastLine+1].x[0] = lines[lastLine].x[1];
		lines[lastLine+1].y[0] = lines[lastLine].y[1];
		lines[lastLine+1].x[1] = lines[lastLine].x[1]+SIZE_LINE;
		do
		{
			lines[lastLine+1].y[1] = lines[lastLine].y[1]+( rand() % LINE_RAND*2 - LINE_RAND );
		}while(lines[lastLine+1].y[1]<2 || lines[lastLine+1].y[1]>62);
		lines[lastLine+1].exist = 1;
		
		lines[lastLine+2].exist = 0; 
	}
	// delete a line
	if(lines[0].x[1] < 0)
	{
		for(i=0; i<Line_cout(); i ++)
		{
			lines[i] = lines[i+1];
		}
		lines = realloc(lines, (Line_cout())*sizeof(Line));
		if(lines == NULL)
			return -1;
	}
	
	return 1;
}

// Draw the lines -- ok
void Line_draw()
{
	int i, j;
	
	for(i=0; i<Line_cout(); i++)
	{
#ifdef BIG_LINES
		for(j = -1; j<2; j++)
			ML_line(lines[i].x[0], lines[i].y[0]+j, lines[i].x[1], lines[i].y[1]+j, ML_BLACK);
#else
		ML_line(lines[i].x[0], lines[i].y[0], lines[i].x[1], lines[i].y[1], ML_BLACK);
#endif
	}
		
}

// Move lines -- ok
void Line_move()
{
	int i;
	
	for(i=0; i<Line_cout(); i++)
	{
		lines[i].x[0]--;
		lines[i].x[1]--;
	}
}

// Cout the lines -- ok
int Line_cout()
{
	int i = 0;
	
	while(lines[i].exist)
		i++;
	return i;
}

// Return the y pos of the line at the circle's pos -- ok
float Line_pos()
{
	int i;
	
	for(i=0; i<Line_cout(); i++)
		if(lines[i].x[0] <= POS_CIRCLE  &&  lines[i].x[1] >= POS_CIRCLE) break;
		
	return (float)(lines[i].y[0]+lines[i].y[1])/2.;
}

// Did the circle collision the line ? -- ~ok
int Line_colision(float yCircle)
{
	if(ML_pixel_test(POS_CIRCLE, (int)yCircle+CIRCLE_WEIGHT*2-1) == ML_BLACK || ML_pixel_test(POS_CIRCLE, (int)yCircle-CIRCLE_WEIGHT*2+1) == ML_BLACK)
		return 1;
	else
		return 0;
}

// Free memory -- ok
void Line_quit()
{
	free(lines);
}


int RTC_getTicks()
{
	static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070}; // déclaration en global des adresses
	static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode; // et des registres
	return (*SysCall)(0, 0, 0, 0, 0x3B); // on déclare la fonction voulue selon son numéro (ici 0x3B)
}